define("epi-ecf-ui/MarketingUtils", [
],

function (
) {
    var marketingUtils = {
        // summary:
        //    This class contains utilities for working with marketing objects
        //    (campaigns, promotions)
        // tags:
        //    public static

        // status: Object
        //      Statuses used on marketing objects
        status : {
            // Note: These should match EPiServer.Commerce.Shell.Rest.Models.CampaignItemStatus
            notSet: 0,
            active: 1,
            pending : 2,
            expired: 3,
            inactive: 4
        },

        // contentTypeIdentifier: Object
        //      Type identifiers for marketing content types
        contentTypeIdentifier: {
            salesCampaign: "episerver.commerce.marketing.salescampaign",
            promotionData: "episerver.commerce.marketing.promotiondata",
            orderPromotion:"episerver.commerce.marketing.orderpromotion",
            entryPromotion: "episerver.commerce.marketing.entrypromotion",
            shippingPromotion: "episerver.commerce.marketing.shippingpromotion"
        },

        getStatusString: function(statusValue){
            switch (statusValue) {
                case this.status.pending:
                    return "pending";
                case this.status.active:
                    return "active";
                case this.status.suspended:
                    return "suspended";
                case this.status.expired:
                    return "expired";
                case this.status.deleted:
                    return "deleted";
                default:
                    return "inactive";
            }
        }
    };

    return marketingUtils;
});