require({cache:{
'url:epi-ecf-ui/widget/viewmodel/templates/DiscountPriorityStatusColumn.html':"﻿<h1>${statusLabel}</h1>\n<p>${fromDate} - ${toDate}</p>"}});
﻿define("epi-ecf-ui/widget/DiscountList", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/Deferred",
    "dojo/string",
    "dojo/when",
// epi
    "epi",
    "epi/datetime",
    "epi/dependency",
    "epi/shell/widget/_ModelBindingMixin",
// epi-ecf-ui
    "../MarketingUtils",
    "./_ConfirmDiscardChangesMixin",
    "./_MarketingListBase",
    "./viewmodel/DiscountListModel",
// resources
    "epi/i18n!epi/nls/commerce.widget.discountpriority",
    "epi/i18n!epi/nls/commerce.widget.marketingitemlist",
    "dojo/text!./viewmodel/templates/DiscountPriorityStatusColumn.html"
], function (
// dojo
    array,
    declare,
    lang,
    aspect,
    Deferred,
    dojoString,
    when,
// epi
    epi,
    epiDate,
    dependency,
    _ModelBindingMixin,
// epi-ecf-ui
    MarketingUtils,
    _ConfirmDiscardChangesMixin,
    _MarketingListBase,
    DiscountListModel,
// resources
    resources,
    marketingResources,
    discountPriorityStatusColumnTemplate
) {
    return declare([_MarketingListBase, _ModelBindingMixin, _ConfirmDiscardChangesMixin], {
        // summary:
        //      A widget to list all promotions
        // tags:
        //      public

        // contextChangeEvent: [public] String
        //      Disable the double click action to grid item.
        contextChangeEvent: "",

        typeIdentifiers: [
            MarketingUtils.contentTypeIdentifier.promotionData
        ],

        // _campaignRootFolder: String
        //      The root folder of campaign
        _campaignRootFolder: null,

        queryName: "getpromotions",

        modelBindingMap: {
            "items": ["items"]
        },

        postCreate: function () {
            this.inherited(arguments);

            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            this._campaignRootFolder = this._campaignRootFolder || contentRepositoryDescriptors.marketing.roots[0];
        },

        startup: function () {
            // summary:
            //      Initialize data for grid.
            // tags:
            //      Protected
            this.inherited(arguments);
            
            this._fetchData();
        },

        createModel: function () {
            return new DiscountListModel();
        },

        getListSettings: function () {
            // summary:
            //      To override grid's store and dnd params
            // tags:
            //      Protected
            var self = this;

            return lang.mixin(this.inherited(arguments), {
                dndParams: {
                    alwaysCopy: false,
                    accept: this.typeIdentifiers || [],
                    // completely disable the grid's copy function by always returning false for the copyState
                    copyState: function (copyKeyPressed, self) {
                        return false;
                    }
                },
                showHeader: false,
                // Need set store to null, to prevent grid using query of store.
                store: null,
                onContextMenuClick: function (e) {                    
                    this.inherited(arguments);
                    self.onContextMenuClick(e);
                }
            });
        },

        onContextMenuClick: function (e) {
            // summary:
            //      Setup command model of selected row
            // tags:
            //      Protected

            this.inherited(arguments);
            var currentRowId = parseInt(this.grid.row(e).id, 10);
            this.model.updateCommandModel({ currentRowId: currentRowId });
        },

        setupEvents: function () {
            this.inherited(arguments);
            this.own(aspect.after(this.grid.dndSource, "onDropData", lang.hitch(this, this._onDndDrop), true));
        },

        onContextChanged: function () {
            // summary:
            //      Refresh list and query to get new promotions data.
            // tags:
            //      Protected
            this._fetchData();
        },

        _getQuery: function () {
            // summary:
            //      Override to set the referenceId as campaign folder as always
            return lang.mixin(this.inherited(arguments), { referenceId: this._campaignRootFolder });
        },

        _fetchData: function () {
            // summary:
            //      Gets promotions data
            // tags:
            //      Private
            if (this.store) {
                when(this.store.query(this._getQuery()), lang.hitch(this, function (promotions) {
                    if (this.model) {
                        this.model.set("items", promotions);
                    }
                }));
            }
        },

        _onDndDrop: function (dndData, source, nodes, copy) {
            // summary:
            //      Topic event processor for /dnd/drop, called to finish the DnD operation.
            // tags:
            //      Private
            if (!this.grid.dndSource.current) {
                return;
            }
            if (this.grid.dndSource === source) {
                this.model.moveItem(nodes[0].rowIndex, this.grid.dndSource.getItem(this.grid.dndSource.current.id).data, this.grid.dndSource.before);
            }
        },

        _updateGrid: function (value) {
            // summary:
            //      Update the grid
            // tags:
            //      private
            if (this.grid && this.model) {
                this.grid.refresh();
                var itemsModel = value || this.model.get("items");
                if (itemsModel) {
                    this.grid.renderArray(itemsModel);
                }
            }
        },

        _setItemsAttr: function (value) {
            this._updateGrid(value);
        },

        getColumnSettings: function () {
            return {
                order: {
                    className: "epi-columnVeryNarrow",
                    sortable: false
                },
                name: {
                    className: "epi-grid--20",
                    get: lang.hitch(this.model, this.model._getNameModel),
                    formatter: lang.hitch(this, this._getNameHtml),
                    sortable: false
                },
                daterange: {
                    className: "epi-grid-column--centered",
                    label: resources.daterange,
                    get: lang.hitch(this.model, this.model._getStatusModel),
                    formatter: lang.hitch(this, this._getStatusHtml),
                    sortable: false
                },
                campaign: {
                    className: "epi-grid--20 epi-grid-column--centered",
                    label: marketingResources.campaign,
                    get: function (item) {
                        return item.properties.campaignName;
                    },
                    sortable: false
                }
            };
        },

        _getStatusHtml: function (model) {
            return dojoString.substitute(discountPriorityStatusColumnTemplate, {
                statusLabel: marketingResources.status[model.statusLabelKey],
                fromDate: epiDate.toUserFriendlyString(model.validFrom, null, null, true),
                toDate: epiDate.toUserFriendlyString(model.validUntil, null, null, true)
            });
        },

        save: function () {
            // summary:
            //      Call save priority data
            // tags:
            //      Publish
            // return:
            //      Deferred object

            var def = this.model.save();
            when(def).then(lang.hitch(this, function (results) {
                var hasError = array.some(results, function (result) {
                    return !result.successful;
                });

                // If has error, keep hasPendingChanges as true, otherwise set to false
                this.model.set("hasPendingChanges", hasError);
            }));

            return def;
        }
    });
});